void MB_Ctrl(){
  switch (u8state) {
    //case 0: leitura das entradas digitais do escravo************************************************************
    case 0:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 3; // function code (this one is registers read)
      Comm_MB.u16RegAdd = 0; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to read
      Comm_MB.au16reg = au16data_DI; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 1:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state++;
      }
    break;

    //case 2: Escrita para as saídas digitais do escravo**********************************************************  
    case 2:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 16; // function code (this one is registers write)
      Comm_MB.u16RegAdd = 1; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
      Comm_MB.au16reg = au16data_DO; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 3:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state++;
      }
    break;

    //case 4: leitura das entradas analógicas do escravo************************************************************
    case 4:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 3; // function code (this one is registers read)
      Comm_MB.u16RegAdd = 2; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to read
      Comm_MB.au16reg = au16data_AI; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 5:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state++;
      }
    break;

    //case 6: Escrita para as saídas digitais do escravo**********************************************************  
    case 6:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 16; // function code (this one is registers write)
      Comm_MB.u16RegAdd = 2; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
      Comm_MB.au16reg = au16data_AO; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 7:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 0;
      }
    break;
  }
}
